
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Coin_earning_rulesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const coin_earning_rules = await db.coin_earning_rules.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        source: data.source
        ||
        null
            ,
            
        active: data.active
        ||
        false
        
            ,
            
        base_doodlecoins: data.base_doodlecoins
        ||
        null
            ,
            
        multiplier: data.multiplier
        ||
        null
            ,
            
        min_streak_days: data.min_streak_days
        ||
        null
            ,
            
        max_streak_days: data.max_streak_days
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return coin_earning_rules;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const coin_earning_rulesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                source: item.source
            ||
            null
            ,
            
                active: item.active
            ||
            false
        
            ,
            
                base_doodlecoins: item.base_doodlecoins
            ||
            null
            ,
            
                multiplier: item.multiplier
            ||
            null
            ,
            
                min_streak_days: item.min_streak_days
            ||
            null
            ,
            
                max_streak_days: item.max_streak_days
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const coin_earning_rules = await db.coin_earning_rules.bulkCreate(coin_earning_rulesData, { transaction });

        // For each item created, replace relation files
        

        return coin_earning_rules;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const coin_earning_rules = await db.coin_earning_rules.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.source !== undefined) updatePayload.source = data.source;
        
        
        if (data.active !== undefined) updatePayload.active = data.active;
        
        
        if (data.base_doodlecoins !== undefined) updatePayload.base_doodlecoins = data.base_doodlecoins;
        
        
        if (data.multiplier !== undefined) updatePayload.multiplier = data.multiplier;
        
        
        if (data.min_streak_days !== undefined) updatePayload.min_streak_days = data.min_streak_days;
        
        
        if (data.max_streak_days !== undefined) updatePayload.max_streak_days = data.max_streak_days;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        updatePayload.updatedById = currentUser.id;

        await coin_earning_rules.update(updatePayload, {transaction});

        
        

        
        

        

        return coin_earning_rules;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const coin_earning_rules = await db.coin_earning_rules.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of coin_earning_rules) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of coin_earning_rules) {
                await record.destroy({transaction});
            }
        });


        return coin_earning_rules;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const coin_earning_rules = await db.coin_earning_rules.findByPk(id, options);

        await coin_earning_rules.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await coin_earning_rules.destroy({
            transaction
        });

        return coin_earning_rules;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const coin_earning_rules = await db.coin_earning_rules.findOne(
            { where },
            { transaction },
        );

        if (!coin_earning_rules) {
            return coin_earning_rules;
        }

        const output = coin_earning_rules.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'coin_earning_rules',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'coin_earning_rules',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.base_doodlecoinsRange) {
                const [start, end] = filter.base_doodlecoinsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    base_doodlecoins: {
                    ...where.base_doodlecoins,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    base_doodlecoins: {
                    ...where.base_doodlecoins,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.multiplierRange) {
                const [start, end] = filter.multiplierRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    multiplier: {
                    ...where.multiplier,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    multiplier: {
                    ...where.multiplier,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.min_streak_daysRange) {
                const [start, end] = filter.min_streak_daysRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    min_streak_days: {
                    ...where.min_streak_days,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    min_streak_days: {
                    ...where.min_streak_days,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.max_streak_daysRange) {
                const [start, end] = filter.max_streak_daysRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    max_streak_days: {
                    ...where.max_streak_days,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    max_streak_days: {
                    ...where.max_streak_days,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.source) {
                where = {
                    ...where,
                source: filter.source,
            };
            }
            
            if (filter.active) {
                where = {
                    ...where,
                active: filter.active,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.coin_earning_rules.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'coin_earning_rules',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.coin_earning_rules.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

